<?php 

class Admin extends db {

	protected $logedIn;
	protected $usertype;
	protected $userId;
	protected $langcode = array(
									'en'=>'English',
									'de'=>'German'
								);
	protected $path;
	protected $order;
	protected $loginTime;
	public $lang;
	public $infos;
	
	
	function __construct(){
		parent::__construct();
		if (!isset($_SESSION)){
			session_start();
		}
		if ($this->databaseConnection()){
			$this->path = ROOT.'include/';
			$infos = new GetInfos();
			$this->infos = $infos->getInfos();
			require($this->path.'lang/'.$this->infos->language.'.php');
			$this->lang = $lang;
			$this->langcode = array_merge($this->langcode, $langcode);
			$this->checkLogin();
		}
	}
	
	protected function login() {
		if (isset($_POST['uid']) && isset($_POST['pwd'])){
			if ($user = $this->getUser($_POST['uid'])){
				if ($user->password == $_POST['pwd']){
					$_SESSION['user'] = $_POST['uid'];
					$_SESSION['pass'] = md5($_POST['pwd']);
					$_SESSION['timeout'] = time() + ADMIN_TIMEOUT;
					$_SESSION['lastlogin'] = $user->last_login;
					$this->logedIn = true;
					$this->user = utf8_decode($user->name);
					$this->userId = $user->id;
					$this->usertype = $user->type;
					$usr= new Users();
					$this->loginTime = $usr->setLastLogin($user->id);
				} else {
					$this->logedIn = false;
					$this->status = false;
					$this->msg = 'wrong password';
				}
			} else {
				$this->logedIn = false;
				$this->status = false;
				$this->msg = 'wrong username';
			}
		}
		return $this->logedIn;
	}
	
	protected function authenticate() {
		if ($this->checkInstallation()){
			if (isset($_SESSION['user']) && isset($_SESSION['pass']) && $_SESSION['timeout'] > time()){
				if ($user = $this->getUser($_SESSION['user'])) {
					if (md5($user->password) == $_SESSION['pass']){
						$_SESSION['timeout'] = time() + ADMIN_TIMEOUT;
						$this->logedIn = true;
						$this->user = utf8_encode($user->name);
						$this->userId = $user->id;
						$this->usertype = $user->type;
						$this->loginTime = $user->last_login;
					} else {
						$this->logedIn = false;
						$this->status = false;
					}
				} else {
					$this->logedIn = false;
					$this->status = false;
				}
			} else {
				$this->logedIn = false;
				$this->status = false;
				$this->msg = 'not logged in';
			}
		} else {
			$this->logedIn = false;
			$this->status = false;
		}
		return $this->logedIn;
	}
	
	public function checkLogin() {
		if ($this->authenticate()){
			$this->msg = 'logged in';
		} else if ($this->login()){
			$this->msg = 'login success';
		}
		return $this->status;
	}
	
	public function getLoginStatus() {
		return $this->logedIn;
	}
	
	public function getLoginTime() {
		return $this->loginTime;
	}

	public function logout() {
		$this->logedIn = false;
		$this->msg = 'logged out';
		$this->user = NULL;
		session_destroy();
	}
	
	protected function getUser($user) {
		$sql = "SELECT * from sz_user WHERE username='$user' LIMIT 1";
		$result = $this->fetchSql($sql);
		if (is_array($result)){
			return $result[0];
		} else {
			return false;
		}
	}
	
	public function checkInstallation(){
		if ($this->databaseConnection()){
			return true;
		} else {
			$this->msg = $this->lang['NOT_CONFIGURED'];
			return false;
		}
	}
	
	public function createEmptyElement(){
		$result = array();
		foreach ($this->tableFields as $key){
			if (isset($this->$key)){
				$result[0]->$key = ($key == 'id')? '0' : ((in_array($key, array('path')))? NULL : $this->$key);
			} else {
				$result[0]->$key = NULL;
			}
		}
		return $result;
	}
			
}