<?php  

class Articles extends Admin {

	protected $tableFields = array('id', 'sort', 'visibility', 'extern', 'field', 'title', 'lead', 'fragments', 'template', 'extern_system', 'extern_id', 'extern_url', 'cache', 'author', 'last_changed');
	protected $fragments;
	protected $field;
	protected $table = 'sz_articles';
	protected $cache = false;
	protected $json = false;
	protected $sort;
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id']))? $_POST['id'] : ((isset($_GET['id']))? $_GET['id'] : false);
		$this->field = (isset($_POST['field'])) ? $_POST['field'] : ((isset($_GET['field']))? $_GET['field'] : false);
		$this->sort = (isset($_POST['sort'])) ? $_POST['sort'] : ((isset($_GET['sort']))? $_GET['sort'] : false);
	}
	
	public function saveArticle(){
		if ($this->logedIn){
			$this->serializeProperties();
			if ($this->id){
				if ($this->update(false, false)){
					$this->msg = 'saved';
					if ($this->cacheArticle()){
						$this->msg = 'saved and cached';
						$this->changed = true;
						$this->buildJsonArticle();
					}
				}
			} else {
				if ($this->create()){
					$this->msg = 'created';
					if ($this->id = $this->lastId){
						if ($this->cacheArticle() && $this->update()){
							$rel = new Relations();
							$rel->saveEmptyRelations($this->id, $this->field);
							$this->msg = 'created and cached';
							$this->changed = true;
							$this->buildJsonArticle();
						}
					}
				}
			}
		}
	}
	
	public function deleteArticle(){
		if ($this->logedIn){
			if ($this->id){
				if ($this->dbDelete()){
					$rel = new Relations();
					$rel->deleteRelations($this->id);
				}
			}
		}
	}
	
	public function addFragmentToArticle(){
		if ($this->logedIn){
			if ($this->serializeValue('fragments')){
				if ($this->id){
					if ($this->update()){
						$this->msg = 'saved';
					}
				}
			} else {
				$this->status = false;
				$this->msg = 'error adding fragment';
			}
		}
	}
	
	public function changeVisibilty(){
		if ($this->logedIn){
			if ($this->serializeValue('visibility')){
				if ($this->id){
					if ($this->update()){
						$this->msg = 'saved';
					}
				}
			} else {
				$this->status = false;
				$this->msg = 'error saving';
			}
		}
	}
	
	public function changePosition(){
		if ($this->logedIn){
			$this->serializePositions();
			if ($this->updatePosition()){
				$this->msg = 'position changed';
			}
		}
	}
	
	public function updateArticleCache(){
		$fragments = new Fragments();
		$fragments->updateImgCache();
		$fragments->updateVideoInfos();
		$a = new GetArticles();
		$articles = $a->getAllArticles();
		foreach ($articles as $article){
			$this->id = $article->id;
			if ($this->cacheArticle(true, false)){
				$this->msg = 'cached';
				$this->buildJsonArticle();
			}
		}
	}
	
	public function updateArticleCacheById($id, $fragments=true){
		if ($this->logedIn){
			if($fragments){
				$f = new Fragments();
				$f->changeImageHtml();
				$f->updateVideoInfos();
			}
			$a = new GetArticles();
			$articles = $a->getArticleById($id);
			foreach ($articles as $article){
				$this->id = $article->id;
				if ($this->cacheArticle(true)){
					$this->msg = 'cached';
					$this->buildJsonArticle();
				}
			}
		}
		
	}
	
	protected function cacheArticle($cacheanyway = false, $update = false){
		if ($this->id){
			$art = new GetArticles();
			$articles = $art->getArticleById($this->id);
			if ($articles[0]->fragments){
				$rel = new GetRelations();
				$relations = $rel->getRelationsForAllFields($this->id);
				if (is_array($articles[0]->fragments)){
					$fragments = new GetFragments();
					$cache = array(0=>'', 1=>'', 2=>'', 3=>'', 4=>'');
					foreach ($articles as $article){
						include($this->path.'cache/article.cache.temp.php');
					}
					$this->cache = join("",$cache);
					$this->json = $cache[1].$cache[2].$cache[3];
					if ($articles[0]->cache != $this->cache || $cacheanyway){
						$this->properties['cache'] = $this->cache;
						if ($this->update(false, $update)){
							return true;
						}
					}
					return false;
				} else {
					return false;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	protected function buildJsonArticle(){
		$szinfos = $this->infos;
		$json_arr['id'] = $this->id;
		$json_arr['url'] = utf8_encode(DOMAIN);
		$json_arr['author'] = utf8_encode($this->user);
		$json_arr['schplitzing'] = $szinfos->title;
		if (isset($this->properties['title'])){
			$json_arr['title'] = $this->properties['title'];
		} else {
			$art = new GetArticles();
			$articles = $art->getArticleById($this->id);
			$json_arr['title'] = $articles[0]->title;
		}
		$json_arr['content'] = utf8_encode($this->json);
		$this->json = json_encode($json_arr);
		$jsonfile = ROOT.'json/'.$this->id.'.json';
		$handle = fopen($jsonfile, 'w');
		fwrite($handle, $this->json);
		fclose($handle);
	}

}


?>