<?php

class Connecting extends Admin {
	
	protected $origin;
	protected $url;
	protected $extern;
	protected $header;
	public $connected = false;
	public $method = false;
	
	function __construct(){
		$this->url = (isset($_GET['szurl'])) ? $_GET['szurl'] : false;
		$this->origin = (isset($_SERVER['HTTP_ORIGIN']))? $_SERVER['HTTP_ORIGIN'] : false;
		$this->header = (strpos($_SERVER['HTTP_HOST'], 'http://') === false)? 'ORIGIN: http://'.$_SERVER['HTTP_HOST'] : 'ORIGIN: '.$_SERVER['HTTP_HOST'];
		if ($this->checkExternSchplitZing()){
			parent::__construct();
		}		
	}
	
	protected function checkExternSchplitZing(){
		$result = false;
		if ($this->url && $this->origin){
			$get_url = SCHPLITZING.'?origin='.DOMAIN.'&struct=ping&szurl='.$this->origin.'&szorigin='.$this->url; 
			$this->connected = curl_get($get_url, array($this->header));
			if ($this->connected){
				$this->connected = json_decode($this->connected);
				if ($this->connected->result){
					$domain = str_replace("http://", "", DOMAIN);
					ini_set('session.cookie_domain', $domain);
					header("Access-Control-Allow-Origin: $this->origin");
					$this->method = (isset($_POST['method']))? $_POST['method'] : false;
				}
				$result = $this->connected->result;
			}
		}
		return $result;
	}
	
	public function loginForm(){
		if ($this->connected->result){
			$info = $this->infos;
			$result = array('connected'=>true,'result'=>false, 'schplitzing'=>$info->title, 'subtitle'=>$info->subtitle,  'author'=>join(' ', $info->author));
		} else {
			$result = array('connected'=>false,'result'=>false);
		}
		echo json_encode($result);
	}
	
	public function listJsonArticles(){
		if ($this->logedIn){
			$art = new GetArticles();
			$info = $this->infos;
			$result = array('connected'=>true,'result'=>true, 'schplitzing'=>$info->title, 'subtitle'=>$info->subtitle,  'author'=>join(' ', $info->author));
			foreach ($this->fields as $field){
				$articles[$field] = $art->getArticlesOfField($field);
				foreach ($articles[$field] as $k=>$a){
					unset($articles[$field][$k]->fragments);
					unset($articles[$field][$k]->visibility);
					unset($articles[$field][$k]->cache);
				}
			}
			$result['articles'] = $articles;
		} else {
			$result = array('connected'=>false,'result'=>false, 'msg'=>$this->msg);
		}
		echo json_encode($result);
	}
	
	public function addArticle(){
		if ($this->logedIn){
			$result = array('connected'=>true,'result'=>false);
			$info = $this->infos;
			$article = new Articles();
			$article->saveArticle();
			$result['result'] = $article->status;
			if ($article->status){
				$result['lastId'] = $article->lastId;
				$post = array('task'=>'create', 'connectedsystem'=>$_POST['extern_system'], 'connectedarticle'=>$_POST['extern_id'], 'originarticleid'=>$article->lastId, 'field'=>$_POST['field']);
				$get_url = SCHPLITZING.'?origin='.DOMAIN.'&struct=connectarticle&id='.$info->identifier.'&pass='.$info->identifierpass;
				$sz = curl_get($get_url, array($this->header), $post);
				$result['schplitzing'] = ($sz)? json_decode($sz) : false;
			}
			echo json_encode($result);
		}
	}
	
	public function sortArticles(){
		if ($this->logedIn){
			$article = new Articles();
			$article->changePosition();
			$article->jsonResponse();
		}
	}		
	
}
	
?>