<?php  

class Fragments extends Admin {

	protected $tableFields = array('id', 'type', 'articles', 'tags', 'title', 'text', 'path', 'resource', 'thumb', 'size', 'html', 'source', 'source_url', 'author', 'last_changed');
	protected $extensions = array(".gif",".jpg",".png",".jpeg");
	protected $type;
	protected $files;
	protected $upload = NULL;
	protected $html = NULL;
	protected $resrc;
	protected $table = 'sz_fragments';
	public $thumbnail = THUMBNAIL;
	public $size = false;
	
	function __construct(){
		parent::__construct();
		$this->type = (isset($_POST['type'])) ? $_POST['type'] : ((isset($_GET['type'])) ? $_GET['type'] : false);
		$this->files = (isset($_FILES)) ? $_FILES : false;
		$this->id = (isset($_POST['id'])) ? $_POST['id'] : ((isset($_GET['id'])) ? $_GET['id'] : false);
		$this->resrc = (isset($_POST['resource'])) ? $_POST['resource'] : NULL;
	}

	
	public function saveFragment(){
		if ($this->logedIn){
			if ($this->id){
				$_POST['articles'] = $this->fragmentInArticles();
				if ($this->type == 'text' || $this->type == 'headline'){
					$this->serializeProperties();
					$this->update();
				} else if ($this->type == 'img'){
					if ($this->files){
						$this->replaceImage();
					} else {
						$this->serializeProperties();
						$this->update();
					}
				} else if ($this->type == 'video'){
					$this->createVideo();
				}
				if ($this->status){
					$this->msg = 'saved';
					if ($_POST['articles']){
						$art = new Articles();
						foreach ($_POST['articles'] as $article){
							$art->updateArticleCacheById($article, false);
						}
						$this->msg = 'saved and article updated';
					}
				}
			} else {
				if ($this->type == 'text' || $this->type == 'headline'){
					$this->serializeProperties();
					$this->create();	
				} else if ($this->type == 'img'){
					$this->createImage();
				} else if ($this->type == 'video'){
					$this->createVideo(true);
				}
				if ($this->status){
					$this->msg = 'saved';
				}
			}
		}
	}
	
	public function fragmentInArticles(){
		$a = strlen($this->id);
		$sql = "SELECT * from sz_articles WHERE fragments LIKE '%$a:\"$this->id\"%'";
		$result = $this->fetchSql($sql);
		if ($result){
			foreach ($result as $key=>$art){
				$ret[$key] = $art->id;	
			}
		} else {
			$ret = false;
		}
		return $ret;
	}
	
	public function deleteFragment(){
		if ($this->logedIn){
			if ($this->id){
				if ($artids = $this->fragmentInArticles()){
					$a = new GetArticles();
					$articles = array();
					foreach ($artids as $key=>$artid){
						$art = $a->getArticleById($artid);
						$articles[$key] = $art[0]->title;
					}
					$this->status = false;
					$this->msg = $this->lang['FRAGMENT_USED'].' \n '.join(" \n ", $articles).' \n '.$this->lang['DELETE_ANYWAY'];
				} else {
					if ($this->type == 'img'){
						if ($this->deleteImage($_POST['img'])){
							$this->dbDelete();
						}
					} else {
						$this->dbDelete();
					}
				}
			}
		}
	}
	
	public function forceDeleteFragment(){
		if ($this->logedIn){
			if ($this->id){
				if ($this->type == 'img'){
					if ($this->deleteImage($_POST['img'])){
						$this->dbDelete();
					}
				} else {
					$this->dbDelete();
				}
			}
		}
	}
	
	public function updateImgCache(){
		$this->changeImageHtml();
	}
	
	protected function createImage(){
		if ($this->uploadImage($this->files['file'])){
			if ($this->typeImg($this->upload)){
				$this->serializeProperties();
				$this->create();
			}
		} else {
			$this->status = false;
			$this->msg = $this->upload;
		}
	}
	
	protected function replaceImage(){
		if (isset($_POST['replace'])){
			$this->deleteImage($_POST['replace']);
		}
		if ($this->uploadImage($this->files['file'])){
			if ($this->typeImg($this->upload)){
				$this->serializeProperties();
				$this->update();
			}
		}

	}
	
	protected function deleteImage($file = false){
		if ($file){
			if (unlink(ROOT . MEDIA_PATH . $file)){
				if (file_exists(ROOT . MEDIA_PATH . "thumb_" .$file)){
					if (unlink(ROOT . MEDIA_PATH . "thumb_" .$file)){
						return true;
					} else {
						return false;
					}
				} else {
					return true;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	protected function uploadImage($files){
		$result = false;
		if (is_uploaded_file($files['tmp_name'])){
			$ext = strtolower(strrchr($files['name'],'.'));
			if (in_array($ext,$this->extensions)){
				//$replace = array(" ", "ä", "ö", "ü", "é", "è", "à");
				//$name = str_ireplace($replace, '', $files['name']);
				$name = preg_replace('/[^A-Za-z0-9]/', '', $files['name']);
				if (file_exists(ROOT . MEDIA_PATH . $name)){
					$new_name = str_replace(str_replace('.', '', $ext), '_'.substr(uniqid( false ), -2).'.jpg' , $name);
				} else {
					$new_name = str_replace(str_replace('.', '', $ext), '.jpg', $name);
				}
				$thumb_name = 'thumb_'.$new_name;
				if (!$files['error']){
					if($files['type'] == "image/pjpeg" || $files['type'] == "image/jpeg"){
				    	$new_img = imagecreatefromjpeg($files['tmp_name']);
				   	} else if ($files['type'] == "image/x-png" || $files['type'] == "image/png"){
				    	$new_img = imagecreatefrompng($files['tmp_name']);
					} else if($files['type'] == "image/gif"){
				    	$new_img = imagecreatefromgif($files['tmp_name']);
					} else {
						$new_img = false;
					}
					if ($new_img){
						list($width, $height) = getimagesize($files['tmp_name']);
						$imgratio=$width/$height;
						if ($imgratio>1){
							$newwidth = UPLOAD_SIZE;
							$newheight = UPLOAD_SIZE/$imgratio;
							$thumbwidth = THUMB_SIZE;
							$thumbheight = THUMB_SIZE/$imgratio;
						}else{
								$newheight = UPLOAD_SIZE;
								$newwidth = UPLOAD_SIZE*$imgratio;
								$thumbheight = THUMB_SIZE;
							$thumbwidth = THUMB_SIZE*$imgratio;
						}
						if (function_exists("imagecreatetruecolor")){
							$resized_img = imagecreatetruecolor($newwidth,$newheight); 
							imagecopyresampled($resized_img, $new_img, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
							if ( imagejpeg ($resized_img, ROOT.MEDIA_PATH.$new_name, 80) ){
								$this->upload = $new_name;
								$this->result = $new_name;
								$result = true;
							} else {
								$result = false;
								$this->upload = 'Could not save File '.$files['name'];
							}
							if ($this->thumbnail){
								$resized_thumb = imagecreatetruecolor($thumbwidth,$thumbheight);
								imagecopyresampled($resized_thumb, $new_img, 0, 0, 0, 0, $thumbwidth, $thumbheight, $width, $height);
								if ( imagejpeg ($resized_thumb, ROOT.MEDIA_PATH.$thumb_name, 80) ){
									$this->thumbnail = $thumb_name;
									$result = true;
								} else {
									$result = false;
									$this->thumbnail = 'Could not save Thumbnail of File '.$files['name'];
								}
							}
						} else {
							$result = false;
							$this->upload = 'GD library is not installed';
						}
					} else {
						$result = false;
						$this->upload = 'Could not create image of type '.$files['type'];
					}
				} else {
					$result = false;
					$this->upload = 'Could not upload File '.$files['name'];
				}
			} else {
				$result = false;
				$this->upload = 'Filetype not supported';
			}
		} else {
			$result = false;
			$this->upload = 'No File uploaded';
		}
		return $result;
	}
	
	protected function typeImg($file = ''){
		if (file_exists(ROOT . MEDIA_PATH . $file)){
			$widths = get_image_widths();
			list($w, $h) = getimagesize(ROOT . MEDIA_PATH . $file);
			$imgratio=$w/$h;
			$this->properties['size'] = $imgratio;
			if ($imgratio > 1.33){
				$height = round(MAX_WIDTH/$imgratio);
				$halfheight = round(HALF_WIDTH/$imgratio);
				$result['aspect'] = '<div class="imgtoload aspect" data-width="100" data-src="' . MEDIA_PATH . $file . '" style="width:' . MAX_WIDTH . 'px;height:' . $height . 'px" ></div>';
				$result['full'] = '<div class="imgtoload full" data-width="100" data-src="' . MEDIA_PATH . $file . '" style="width:' . HALF_WIDTH . 'px;height:' . $halfheight . 'px" ></div>';
				$result['half'] = '<div class="imgtoload half" data-width="50" data-src="' . MEDIA_PATH . $file . '" style="width:' . HALF_WIDTH/2 . 'px;height:' . $height/2 . 'px" ></div>';
				foreach ($widths as $key => $value){
					$height = round($h/$w*$value);
					$result[$key] = '<div class="imgtoload '.$key.'" data-src="' . MEDIA_PATH . $file . '" style="width:' . $value . ';height:' . $height . '" ></div>';
				}
				$this->size = "100%";
			} else {
				$width = round(MAX_HEIGHT*$imgratio);
				$height = round(MAX_WIDTH/$imgratio);
				$halfheight = round(HALF_WIDTH/$imgratio);
				$percent = round(100/MAX_WIDTH*$width);
				$result['aspect'] = '<div class="imgtoload aspect" data-width="' . $percent . '" data-src="' . MEDIA_PATH . $file . '" style="width:' . $width . 'px;height:' . MAX_HEIGHT . 'px" ></div>';
				$result['full'] = '<div class="imgtoload full" data-width="100" data-src="' . MEDIA_PATH . $file . '" style="width:' . HALF_WIDTH . 'px;height:' . $halfheight . 'px" ></div>';
				$result['half'] = '<div class="imgtoload half" data-width="50" data-src="' . MEDIA_PATH . $file . '" style="width:' . MAX_WIDTH/2 . 'px;height:' . $height/2 . 'px" ></div>';
				foreach ($widths as $key => $value){
					$value = $value*0.75;
					$height = round($h/$w*$value);
					$result[$key] = '<div class="imgtoload '.$key.'" data-src="' . MEDIA_PATH . $file . '" style="width:' . $value . 'px;height:' . $height . 'px" ></div>';
				}
				$this->size = $percent;
			}
			$this->html = $result;
			return true;
		} else {
			return false;
		}
	}
	
	protected function createVideo($new = false){
		if ($this->resrc == 'vimeo'){
			if ($video = $this->typeVimeo($_POST['video'])){
				$this->files = 'video';
				$this->html = $video->html;
				$this->upload = $_POST['video'];
				$this->thumbnail = (isset($video->thumbnail_large)) ? $video->thumbnail_large : NULL;
				$_POST['source'] = $video->user_name;
				$_POST['source_url'] = $video->user_url;
				$_POST['text'] = (isset($video->description)) ? $video->description : NULL;
				$this->size = (isset($video->width) && isset($video->height)) ? $video->width/$video->height : NULL;
				$_POST['size'] = $video->size;
				$this->serializeProperties();
				if ($new){
					if ($this->create()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				} else {
					if ($this->update()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				}
				
			}
		} else if ($this->resrc == 'youtube'){
			if ($video = $this->typeYoutube($_POST['video'])){
				$this->files = 'video';
				$this->html = $video->html;
				$this->upload = $_POST['video'];
				$this->thumbnail = 'http://img.youtube.com/vi/'.$video->id.'/0.jpg';
				$_POST['source'] = '<a href="http://www.youtube.com/user/'.$video->author->name.'" class="source_link" target="_blank">'.$video->author->name.'</a>';
				$_POST['text'] = (isset($video->content)) ? $video->content : NULL;
				$_POST['title'] = ($_POST['title'])? $_POST['title'] : $video->title;
				$_POST['size'] = 100;
				$this->serializeProperties();
				if ($new){
					if ($this->create()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				} else {
					if ($this->update()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				}
			}
		} else if ($this->resrc == 'soundcloud'){
			if ($video = $this->typeSoundcloud($_POST['video'])){
				$this->files = 'video';
				$this->html = $video->html;
				$this->upload = $_POST['video'];
				$this->thumbnail = $video->thumbnail_url;
				$_POST['source'] = '<a href="'.$_POST['video'].'" class="source_link" target="_blank">'.$video->title.'</a>';
				$_POST['text'] = (isset($video->description)) ? $video->description : NULL;
				$_POST['title'] = ($_POST['title'])? $_POST['title'] : $video->title;
				$_POST['size'] = 100;
				$this->serializeProperties();
				if ($new){
					if ($this->create()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				} else {
					if ($this->update()){
						$this->result = (isset($video->id)) ? $video->id : NULL;
					}
				}
			}
		}
	}
	
	protected function typeVimeo($resource = false){
		$result = false;
		$resource = str_replace("http://vimeo.com/", "", $resource);
		$resource = str_replace("http://www.vimeo.com/", "", $resource);
		if ($resource){
			$json_url = VIMEO_ENDPOINT.$resource.'.json';
			$result = json_decode(curl_get($json_url));
			if (is_array($result)){
				$result = $result[0];
			}
			if (isset($result->id)){
				$height = round(100/VIDEO_HEIGHT*(VIDEO_WIDTH*$result->height/$result->width));
				$minheight = round(290*($height/100));
				$result->html = '<iframe src="http://player.vimeo.com/video/'.$result->id.'?byline=0&amp;portrait=0&amp;js_api=1" width="100%" height="100%" style="width:100%;height:100%;min-height:'.$minheight.'px" frameborder="0"></iframe>';
				$result->size = $height;
			} else {
				$result = false;
			}
		}
		return $result;
	}
	
	protected function typeYoutube($resource = false){
		$result = false;
		if (stripos($resource, "youtube")){
			preg_match("/v=([^&]+)/i", $resource, $id);
			$resource = (isset($id[1]))? $id[1] : false;
		}
		if ($resource){
			$url = 'http://gdata.youtube.com/feeds/api/videos/' . $resource;
			$result = simplexml_load_file($url);
			//$result->html = '<object width="'.VIDEO_WIDTH.'" height="'.VIDEO_HEIGHT.'"><param name="movie" value="http://www.youtube.com/v/'.$video->id.'?fs=0&rel=0"></param><param name="allowFullScreen" value="false"></param><param name="allowscriptaccess" value="always"></param><param name="showinfo" value="false"></param><param name="rel" value="0"></param><embed src="http://www.youtube.com/v/'.$video->id.'?fs=0&rel=0" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.VIDEO_WIDTH.'" height="'.VIDEO_HEIGHT.'"></embed></object>';
			$result->html = '<iframe class="youtube-player" type="text/html" width="100%" height="96%" style="width:100%;height:96%;min-height:290px" src="http://www.youtube.com/embed/'.$resource.'" frameborder="0">
</iframe>';
			$result->id = $resource;
		}
		return $result;
	}

	protected function typeSoundcloud($resource = false){
		$result = false;
		if ($resource){
			$json_url = "http://soundcloud.com/oembed?url=".$resource."&format=json&maxheight=220";
			$result = json_decode(curl_get($json_url));
			if($result){
				if (is_array($result)){
					$result = $result[0];
				}
			} else {
				$result = false;
			}
		}
		return $result;
	}
	
	public function changeImageHtml(){
		if ($this->logedIn){
			$f = new GetFragments();
			$fragments = $f->getFragmentsByType('img');
			if ($fragments){
				foreach ($fragments as $fragment){
					if ($this->typeImg($fragment->path)){
						$this->id = $fragment->id;
						$this->properties['html'] = serialize($this->html);
						$this->update(false, false);
					}
				}
			}
		}
	}
	
	public function updateVideoInfos(){
		if ($this->logedIn){
			$f = new GetFragments();
			$fragments = $f->getFragmentsByType('video');
			if ($fragments){
				foreach ($fragments as $fragment){
					$this->id = $fragment->id;
					$this->resrc = $fragment->resource;
					$this->type = $fragment->type;
					$_POST['video'] = $fragment->path;
					$this->createVideo();
				}
			}
		}
	}

}


?>