<?php  

class Infos extends Admin {

	protected $tableFields = array('id', 'title', 'subtitle', 'description', 'screenshot', 'keywords', 'categories', 'author', 'address', 'language', 'fields', 'identifier', 'identifierpass', 'connect', 'last_connected', 'public', 'last_changed');
	protected $table = 'sz_infos';
	protected $serializevalues = array('title', 'subtitle', 'description', 'keywords', 'categories', 'author', 'address', 'fields');
	protected $extensions = array(".gif",".jpg",".png",".jpeg");
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id'])) ? $_POST['id'] : 1;
	}

	public function saveInfos(){
		if ($this->logedIn){
			$this->serializeProperties();
			if ($this->update()){
				$this->changed = true;
				$this->msg = 'saved';
			}
		}
	}
	
	public function activateConnection(){
		if ($this->logedIn){
			$this->properties['connect'] = 1;
			if ($this->update()){
				$this->msg = 'connection activated';
			}
		}
	}
	
	public function lastConnected(){
		if ($this->logedIn){
			$this->properties['last_connected'] = date("Y-m-d H:m:s");;
			if ($this->update(false, false)){
				$this->msg = date("F j, Y H:i:s");
			}
		}
	}
	
	public function getScreenshotData(){
		if ($this->logedIn){
			$a = new GetArticles();
			$data = $a->getArticleInclRelations($this->id);
			echo json_encode($data);
		}
	}

	public function getArticleTitles(){
		if ($this->logedIn){
			$a = new GetArticles();
			$data = $a->getArticleTitles();
			echo json_encode($data);
		}
	}
	
	public function imgFromRawData(){
		if (isset($_POST['rawdata'])){
			$data = $_POST['rawdata'];
			$file = $_POST['screenshot'];
			if ($this->infos->screenshot && $this->infos->screenshot != ''){
				if (file_exists(ROOT.MEDIA_PATH.$this->infos->screenshot)){
					unlink(ROOT.MEDIA_PATH.$this->infos->screenshot);
				}
			}
			$uri =  base64_decode(substr($data,strpos($data,",")+1));
			$screenshot = fopen(ROOT.MEDIA_PATH.$file, "wb");
	 		fwrite($screenshot, $uri);
	  		fclose($screenshot);
	  		$this->status = true;
	  		$this->msg = 'Screenshot created';
	  		$this->saveInfos();
	  	}
	}
	
	public function uploadScreenshot(){
		$result = false;
		$file = $_FILES['file'];
		if (is_uploaded_file($file['tmp_name'])){
			$ext = strtolower(strrchr($file['name'],'.'));
			if (in_array($ext,$this->extensions)){
				$name = preg_replace('/[^A-Za-z0-9]/', '', $file['name']);
				if (file_exists(ROOT . MEDIA_PATH . $name)){
					$new_name = str_replace(str_replace('.', '', $ext), '_'.substr(uniqid( false ), -2).'.jpg' , $name);
				} else {
					$new_name = str_replace(str_replace('.', '', $ext), '.jpg', $name);
				}
				if (!$file['error']){
					if($file['type'] == "image/pjpeg" || $file['type'] == "image/jpeg"){
				    	$new_img = imagecreatefromjpeg($file['tmp_name']);
				   	}elseif ($file['type'] == "image/x-png" || $file['type'] == "image/png"){
				    	$new_img = imagecreatefrompng($file['tmp_name'][$key]);
					}elseif($file['type'] == "image/gif"){
				    	$new_img = imagecreatefromgif($file['tmp_name']);
					}
					list($width, $height) = getimagesize($file['tmp_name']);
					$imgratio=$width/$height;
					$newwidth = UPLOAD_SIZE;
					$newheight = UPLOAD_SIZE/$imgratio;
					if (function_exists("imagecreatetruecolor")){
						$resized_img = imagecreatetruecolor($newwidth,$newheight);
						imagecopyresampled($resized_img, $new_img, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
						if ( imagejpeg ($resized_img, ROOT.MEDIA_PATH.$new_name, 80) ){
							$this->msg = $new_name;
							$this->result = $new_name;
							$result = true;
						} else {
							$result = false;
							$this->msg = 'Could not save File '.$file['name'];
						}
					} else {
						$result = false;
						$this->msg = 'GD library is not installed';
					}
				} else {
					$result = false;
					$this->msg = 'Could not upload File '.$files['name'];
				}
			} else {
				$result = false;
				$this->msg = 'Filetype not supported';
			}
		} else {
			$result = false;
			$this->msg = 'No File uploaded';
		}
		$this->status = $result;
		if ($result){
			if ($this->infos->screenshot && $this->infos->screenshot != ''){
				if (file_exists(ROOT.MEDIA_PATH.$this->infos->screenshot)){
					unlink(ROOT.MEDIA_PATH.$this->infos->screenshot);
				}
			}
			$this->properties['screenshot'] = $this->result;
			$this->saveInfos();
		}
	}


}


?>