<?php
	
class Relations extends Admin {
	
	protected $tableFields = array('id', 'articleid', 'relationid', 'relationfield', 'last_changed');
	protected $field;
	protected $table = 'sz_relations';
	protected $rel;
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id'])) ? $_POST['id'] : false;
		$this->rel = (isset($_POST['relations'])) ? $_POST['relations'] : false;
	}
	
	public function saveRelations(){
		if ($this->logedIn){
			$rel = new GetRelations();
			$relations = $rel->getSortedRelations($this->id);
			foreach ($this->rel as $field=>$article){
				if (isset($relations[$field])){
					if ($relations[$field] != $article){
						$this->properties['relationid'] = $article;
						$where = array('articleid'=>$this->id, 'relationfield'=>$field);
						if ($this->update($where)){
							$this->changed = true;
							$this->msg = 'saved';
						}
					}
				} else {
					$this->properties['relationid'] = $article;
					$this->properties['articleid'] = $this->id;
					$this->properties['relationfield'] = $field;
					if ($this->create()){
						$this->changed = true;
						$this->msg = 'created';
					}
				}
			}
			$art = new Articles();
			$art->updateArticleCacheById($this->id);
		}
	}
	
	public function saveEmptyRelations($id, $originfield){
		if ($this->logedIn){
			foreach ($this->fields as $field){
				if ($field != $originfield){
					$this->properties['relationid'] = 'e';
					$this->properties['articleid'] = $id;
					$this->properties['relationfield'] = $field;
					$this->create();
				}
			}
		}
	}
	
	public function emptyRelationOnFieldChange(){
		if ($this->logedIn && $this->id){
			if (isset($_POST['oldfield']) && isset($_POST['newfield'])){
				$this->properties['relationid'] = 'e';
				$this->properties['relationfield'] = $_POST['oldfield'];
				$where = array('articleid'=>$this->id, 'relationfield'=>$_POST['newfield']);
				if ($this->update($where)){
					$this->msg = 'relations changed';
				}
			}
		}
	}
	
	public function deleteRelations($id=false){
		if ($this->logedIn){
			$this->id = ($id)? $id : $this->id;
			if ($this->id){
				$whereclause = array('articleid'=>$this->id);
				$this->dbDelete($whereclause);
			}
		}
	}
	
	public function deleteRelationById($id=false){
		if ($this->logedIn){
			$this->id = ($id)? $id : $this->id;
			if ($this->id){
				$this->dbDelete();
			}
		}
	}
	
}	
	
?>