<?php

class RenderSchplitZing extends Admin {
	
	protected $task = 'save';
	protected $structure = 'front';
	protected $mode;
	protected $vars = false;
	protected $field = 1;
	protected $type;
	protected $template;
	protected $target = "admin/index.php";
	protected $method = "post";
	protected $formvars = array(
				'single' => array('header'=>true, 'container'=>true, 'form'=>true, 'tools'=>false, 'footer'=>true),
				'inlist' => array('header'=>true, 'container'=>false, 'form'=>true, 'tools'=>false, 'footer'=>true),
				'container' => array('header'=>true, 'container'=>true, 'form'=>false, 'tools'=>false, 'footer'=>true),
				'list' => array('header'=>false, 'container'=>false, 'form'=>true, 'tools'=>true, 'footer'=>false),
				'form' => array('header'=>false, 'container'=>false, 'form'=>true, 'tools'=>false, 'footer'=>false),
				'tools' => array('header'=>false, 'container'=>false, 'form'=>true, 'tools'=>true, 'footer'=>false)
			);
	protected $form = false;
	protected $tools = false;
	protected $container = false;
	protected $header = false;
	protected $footer = false;
	protected $preview = false;
	protected $sorting = 'type';
	protected $extern = false;
	protected $template_vars = array(
				'text' => array('text'),
				'headline' => array('headline'),
				'image' => array('img','text'),
				'images' => array('img','img','img','img','text'),
				'blog' => array('img','text','img','text'),
				'video' => array('video', 'text'),
			);
	
	function __construct(){
		parent::__construct();
		$this->task = (isset($_GET['task'])) ? $_GET['task'] : $this->task;
		$this->structure = (isset($_GET['struct'])) ? $_GET['struct'] : $this->structure;
		$this->type = (isset($_GET['type'])) ? $_GET['type'] : false;
		$this->template = (isset($_GET['temp'])) ? $_GET['temp'] : false;
		$this->id = (isset($_GET['id'])) ? $_GET['id'] : false;
		$this->field = (isset($_GET['field'])) ? $_GET['field'] : $this->field;
		$this->sorting = (isset($_GET['order'])) ? $_GET['order'] : $this->sorting;
		$this->container = (isset($_GET['container'])) ? $_GET['container'] : $this->container;
		$this->header = (isset($_GET['header'])) ? $_GET['header'] : $this->header;
		$this->footer = (isset($_GET['footer'])) ? $_GET['footer'] : $this->footer;
		$this->form = (isset($_GET['form'])) ? $_GET['form'] : $this->form;
		$this->tools = (isset($_GET['tools'])) ? $_GET['tools'] : $this->tools;
		$this->preview = (isset($_GET['preview'])) ? $_GET['preview'] : $this->preview;
		$this->mode = $this->structure;
	}
	
	protected function formSetVars($vars=array()){
		if (array_key_exists('header', $vars)){ $this->header = $vars['header']; }
		if (array_key_exists('container', $vars)){ $this->container = $vars['container']; }
		if (array_key_exists('form', $vars)){ $this->form = $vars['form']; }
		if (array_key_exists('tools', $vars)){ $this->tools = $vars['tools']; }
		if (array_key_exists('footer', $vars)){ $this->footer = $vars['footer']; }
	}
	
	protected function formOpen($formvars='single', $mode=false, $position='left', $value=false, $key=false){
		if ($formvars && array_key_exists($formvars, $this->formvars)){
			$this->formSetVars($this->formvars[$formvars]);
		}
		if ($mode){ $this->mode = $mode; }
		include($this->path.'forms/form.open.php');
	}
	
	protected function formDraw($value=false, $mode=false){
		if ($mode){ $this->mode = $mode; }
		if (file_exists($this->path.'forms/'.$this->mode.'.form.temp.php')){
			include($this->path.'forms/'.$this->mode.'.form.temp.php');
		}
	}
	
	protected function formClose($formvars='single', $mode=false, $value=false){
		if ($formvars && array_key_exists($formvars, $this->formvars)){
			$this->formSetVars($this->formvars[$formvars]);
		}
		if ($mode){ $this->mode = $mode; }
		include($this->path.'forms/form.close.php');
	}
	
	public function frontend(){
		if ($this->databaseConnection()){
			$art = new GetArticles();
			$rel = new GetRelations();
			$usr = new GetUsers();
			include($this->path.'template/header.temp.php');
			include($this->path.'template/main.temp.php');
			include($this->path.'template/overlay.temp.php');
			if ($this->logedIn){
				include($this->path.'template/menu.temp.php');
			}
			include($this->path.'template/footer.temp.php');
		} else {
			include($this->path.'install/install.inc.php');
		}
	}
	
	public function backend(){
		if ($this->logedIn){
			include($this->path.'template/header.temp.php');
			if (file_exists($this->path.'forms/'.$this->structure.'.menu.temp.php')){ include($this->path.'forms/'.$this->structure.'.menu.temp.php'); }
			$function = $this->structure."Forms";
			$this->$function();
			include($this->path.'template/menu.temp.php');
			include($this->path.'template/footer.temp.php');
		} else {
			$this->frontend();
		}
	}
	
	protected function settingsForms(){
		include($this->path.'template/edit.open.temp.php');
		$language = scandir(ROOT.'include/lang/');
		foreach($this->langcode as $code=>$lang){
			if (in_array($code.'.php', $language)){
				$this->infos->lang[$code] = $lang;
			}
		}
		$this->formOpen('single', 'infos', 'infos navigate', $this->infos, $this->infos->id);
		$this->formDraw($this->infos);
		$this->formClose();
		$usr = new GetUsers();
		$users = $usr->getUsers();
		$this->formOpen('container', 'users', 'hidden edit_users navigate');
		foreach ($users as $user){
			$this->formOpen('list', false, false, $user, $user->id);
			$this->formDraw($user);
			$this->formClose('list', false, $user);
		}
		$this->formClose('container');
		include($this->path.'forms/screenshot.form.temp.php');
		include($this->path.'template/edit.close.temp.php');
	}
	
	public function getUsersForm($id=false){
		if ($this->logedIn){
			$usr = new GetUsers();
			$users = $usr->getUser($id);
			if ($users){
				foreach ($users as $user){
					$this->formOpen(false, 'users', false, $user, $user->id);
					$this->formDraw($user);
					$this->formClose(false, false, $user);
				}
			} else {
				$this->formOpen(false, 'users', false, '0');
				$this->formDraw(false);
				$this->formClose(false, false, false);
			}
		}
		
	}
	
	protected function articlesForms(){
		include($this->path.'template/edit.open.temp.php');
		$ar = new GetArticles();
		$infos = new GetInfos();
		$fieldnames = $infos->getFieldNames();
		foreach ($this->fields as $field){
			$articles = $ar->getArticlesOfField($field);
			include($this->path.'forms/articles.list.temp.php');
		}
		include($this->path.'template/edit.close.temp.php');
	}
	
	protected function relationsForms(){
		include($this->path.'template/edit.open.temp.php');
		$ar = new GetArticles();
		$infos = new GetInfos();
		$rel = new GetRelations();
		$fieldnames = $infos->getFieldNames();
		foreach ($this->fields as $field){
			$articles = $ar->getArticlesOfField($field);
			include($this->path.'forms/relations.list.temp.php');
		}
		include($this->path.'template/edit.close.temp.php');
	}
	
	protected function contentForms(){
		include($this->path.'template/edit.open.temp.php');
		$ar = new GetArticles();
		$rel = new GetRelations();
		$fieldnames = $this->infos->fields;
		foreach ($this->fields as $field){
			$articles = $ar->getArticlesOfField($field);
			include($this->path.'forms/content.list.temp.php');
		}
		include($this->path.'template/edit.close.temp.php');
	}
	
	protected function networkForms(){
		include($this->path.'template/edit.open.temp.php');
		if($this->infos->connect){
			$ar = new GetArticles();
			$fieldnames = $this->infos->fields;
			foreach ($this->fields as $field){
				$articles = $ar->getArticlesOfField($field);
				include($this->path.'forms/network.list.temp.php');
			}
		} else {
			include($this->path.'forms/network.connect.temp.php');
		}
		include($this->path.'template/edit.close.temp.php');
	}
	
	protected function fragmentsForms(){
		include($this->path.'template/edit.open.temp.php');
		$fr = new GetFragments();
		$tags = new GetTags();
		$fragments = $fr->getAllFragments($this->sorting, true);
		$fragmentorder = $this->separateFragmentOrder($fragments);
		include($this->path.'forms/fragments.list.temp.php');
		include($this->path.'forms/tags.list.temp.php');
		if ($this->id !== false){
			$this->structure = 'article';
			if ($this->id == 0){
				$art = new Articles();
				$articles = $art->createEmptyElement();
			} else {
				$art = new GetArticles();
				$articles = $art->getArticleById($this->id);
			}
			foreach ($articles as $article){
				$this->formOpen('single', 'articles', 'right', $article, $article->id);
				$this->formDraw($article);
				$this->container = false; $this->footer = false;
				$this->formClose('form', false, $article);
				include($this->path.'forms/articles.preview.temp.php');
				$this->formClose('container', false, $article);
			}
		}
		include($this->path.'template/edit.close.temp.php');
	}
	
	public function getFragmentsForm($id=false){
		if ($this->logedIn){
			$fr = new GetFragments();
			if ($id) { $this->id = $id; }
			$fragments = $fr->getFragmentsById($this->id);
			if (!$fragments){ $f = new Fragments(); $fragments = $f->createEmptyElement(); }
			foreach ($fragments as $fragment){
				$this->formOpen('form', 'fragments', false, $fragment, $fragment->id);
				$this->formDraw($fragment);
				$this->formClose(false, false, $fragment);
			}
		}
		
	}
	
	public function getFragmentsPreview($id=false){
		if ($this->logedIn){
			$fr = new GetFragments();
			if ($id) { $this->id = $id; }
			$fragments = $fr->getFragmentsById($this->id);
			if ($fragments){
				foreach ($fragments as $fragment){
					include($this->path.'forms/fragments.preview.temp.php');
				}
			}
		}
	}
	
	public function getFragmentsListed($id=false){
		if ($this->logedIn){
			$fr = new GetFragments();
			if ($id) { $this->id = $id; }
			$fragments = $fr->getFragmentsById($this->id, true);
			if ($fragments){
				foreach ($fragments as $fragment){
					include($this->path.'forms/fragments.listed.temp.php');
				}
			}
		}
	}
	
	public function getFragmentsContainer(){
		$fr = new GetFragments();
		$article->extern = false;
		$article->template = $this->template;
		$article->fragments = array();
		foreach($this->template_vars[$this->template] as $k=>$type){
			$article->fragments[$k] = ($_GET['key'.$k])? $_GET['key'.$k] : NULL;
		}
		include($this->path.'forms/articles.preview.temp.php');
	}
	
	public function getTagsForm($id=false){
		if ($this->logedIn){
			$t = new GetTags();
			if ($id) { $this->id = $id; }
			$tags = $t->getTagById($this->id);
			if ($tags){
				foreach ($tags as $tag){
					$this->formOpen('form', 'tags', false, $tag, $tag->id);
					$this->formDraw($tag);
					$this->formClose(false, false, $tag);
				}
			} else {
				$this->formOpen('inlist', 'tags', false, '0');
				$this->formDraw(false);
				$this->formClose(false, false, false);
			}
		}
		
	}
	
	public function loginForm(){
		$this->formDraw(false, 'login');
	}
	
	public function separateFragmentOrder($ar, $order = 'type'){
		$order = ($this->sorting)? $this->sorting : $order;
		$separated = array();
		if (is_array($ar)){
			foreach ($ar as $key=>$fr){
				if (!$fr->$order){
					$separated[0][$key] = $fr;
				} else {
					if ($order == 'last_changed'){
						$separated[date("j.n.Y" , strtotime($fr->$order))][$key] = $fr;
					} else {
						$separated[$fr->$order][$key] = $fr;
					} 
				}
			}
		}
		return $separated;
	}
	
	public function getStructure(){
		return $this->structure;
	}
	
	protected function createEmptyForm(){
		$array = array(
			'id' => 0,
			'type' => $this->type,
			'title' => NULL,
			'tags' => NULL,
			'text' => NULL,
			'source' => NULL,
			'path' => false,
			'thumb' => false,
			'html' => NULL,
			'last_changed' => date("j.n.Y")
		);
		$result[0] = (object)$array;
		return $result;
	}
	
}


?>