<?php  

class Users extends Admin {

	protected $tableFields = array('id', 'name', 'username', 'password', 'type', 'email', 'last_login', 'last_changed');
	protected $table = 'sz_user';
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id'])) ? $_POST['id'] : false;
	}

	public function saveUser(){
		if ($this->logedIn){
			$this->serializeProperties();
			if ($this->id){
				if ($this->update()){
					$this->msg = 'saved';
				}
			} else {
				if ($this->create()){
					$this->msg = 'create';
				}
			}
		}
	}
	
	public function deleteUser(){
		if ($this->logedIn){
			if ($this->id != $this->userId && $this->usertype == 'admin'){
				$this->dbDelete();
			} else if ($this->id == $this->userId){
				$this->msg = "You cannot delete the user you are logged in with";
			} else {
				$this->msg = "You don't have the rights to delete the user";
			}
		}
	}
	
	public function changePassword(){
		if ($this->logedIn){
			if (isset($_POST['password'])){
				if (is_array($_POST['password'])){
					$pass = $_POST['password'][0];
					foreach ( $_POST['password'] as $password){
						if ($pass != $password ){
							$this->status = false;
						} else {
							$this->status = true;
						}
					}
				}
			}
			if ($this->status){
				$this->properties['password'] = $pass;
				if ($this->update()){
					$this->msg = 'password changed';
				}
			}
		}
	}
	
	public function setLastLogin($id = false){
		if ($id){
			$this->id = $id;
		}
		$this->properties['last_login'] = date("Y-m-d H:m:s");
		$this->update(false, false);
		return $this->properties['last_login'];
	}

}


?>