<?php 

function curl_get($url, $header=false, $post=false) {
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    if ($header && is_array($header)){
    	curl_setopt($curl,CURLOPT_HTTPHEADER,$header);
    }
    if ($post && is_array($post)){
    	curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
    }
    $return = curl_exec($curl);
    curl_close($curl);
    return $return;
}

function redirect_to($location = NULL){
	if($location != NULL){
		header("Location: {$location}");
		exit;
	}
}

function get_image_widths() {
	$w = explode(",",SCREEN_WIDTH);
	$widths = array();
	foreach ($w as $width){
		$k = explode("=",$width);
		$key = $k[0];
		$val = $k[1];
		$widths[$key] = $val;
	}
	return $widths;
}

function array_depth($arr) {
    if (!is_array($arr)) { return 0; }
    $arr = json_encode($arr);
    $varsum = 0; $depth  = 0;
    for ($i=0;$i<strlen($arr);$i++)
    {
        $varsum += intval($arr[$i] == '[') - intval($arr[$i] == ']');
        if ($varsum > $depth) { $depth = $varsum; }
    }
    return $depth;
}

function getPublicObjectVars($obj) {
  return get_object_vars($obj);
}

function mailto($e) {
	$email = $e;
	$tag = '<a href="mailto:' . $email . '">' . $email . '</a>';
	$chars = str_split($tag);
	$strOut = '';
	foreach($chars as $char) {
		$strOut .= ord($char);
		$strOut .= ',';
	}
	$strOut = rtrim($strOut,',');
	
	$JStag = '<script type="text/javascript">{';
	$JStag .= '	document.write(String.fromCharCode(' . $strOut . '))';
	$JStag .= '}</script>';
	return $JStag;
}

function dataAttributeDecode($string, $utfdecode=true){
	if ($utfdecode){
		$string = utf8_decode($string);
	}
	$string = str_replace('"', '&quot;', $string);
	$string = str_replace("'", "&#039;", $string);
	return $string;
}

function shortenString($string, $limit=28, $elipses=true){
	if (strlen($string) > $limit){
		$string = substr($string,0,$limit);
		$pos=strrpos($string, ' ');
		$result = (!$pos)? $string : (($elipses)? substr($string,0,$pos).'…' : substr($string,0,$pos));
	} else {
		$result = $string;
	}
	return $result;
}

?>