(function( $ ){

	var methods = {
		init : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.screenshot.defaults, options );
      		}
      		opt = $.fn.screenshot.defaults;
      		$this = $(this);
      		if ($('#article_list').size() < 1){
      			var list = $('<select>', { id : 'article_list' }).appendTo($this.find('#choose_article'));
	      		$.each(opt.articles, function(i,a){
	      			list.append('<option value="'+a.id+'">'+a.title+'</option>');
	      		});
      		} else {
      			var list = $('#article_list');
      		}
      		var d = $this.find('#create_screenshot');
      		$this.removeClass('show upload').addClass('create');
      		$('.edit_header.edit_screenshot').removeClass('hide');
      		if(!opt.canvas){
      			$this.screenshot.defaults.canvas = $('<canvas id="screenshot" width="400" height="300"></canvas>').appendTo(d);
      		}	
      		f.loaded();
      		list.bind('change', function(){
      			f.loading();
      			$.post(opt.adminpath, { form : 'screenshot', task : 'getdata', id : $(this).val() }, function(d) {
					$this.screenshot('create',{data : d });
				}, 'json');      			
      		});
      	},
    	create : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.screenshot.defaults, options );
      		}
      		opt = $.fn.screenshot.defaults;
      		console.log(opt.data);
      		$this = $(this);
      		$this.screenshot.defaults.rawdata = false;
      		var canvas = opt.canvas;
      		$('button.screenshotsave').unbind('click').bind('click', function(){
      			if (opt.rawdata){
      				var d = new Date();
      				var file = 'screenshot'+d.getFullYear()+(d.getMonth()+1)+d.getDate()+'.jpg';
      				f.returnData($this, canvas[0]);
      				$.post(opt.adminpath, { form : 'screenshot', task : 'create', rawdata : opt.rawdata, screenshot : file }, function(d) {
      					f.preview(file);
 						$('.edit_form.infos_form input[name="screenshot"]').val(file);
						$this.screenshot('remove');
					}, 'json');
      			}
      		});
      		$('button.screenshotcancel').unbind('click').bind('click', function(){
      			$this.screenshot('remove');
      		});
      		if (canvas[0].getContext) {
      			if (opt.textscript){
      				f.drawCanvas($this, canvas);
      			} else {
      				$.getScript(opt.scriptpath+'CanvasText-0.4.1.js', function(){
      					$this.screenshot.defaults.textscript = true;
	      				f.drawCanvas($this, canvas);
	      			});
      			}
      						    
			}
			
      	},
      	upload : function( options ){
			if ( options ) { 
        		$.extend( $.fn.screenshot.defaults, options );
      		}
      		opt = $.fn.screenshot.defaults;
      		$this = $(this);
      		$this.removeClass('show create').addClass('upload');
      		$('.edit_header.edit_screenshot').removeClass('hide');
      		$('button.screenshotsave').unbind('click').bind('click', function(){
      			f.loading();
	      		$('#upload').ajaxSubmit({
					success:   		function(data, status, xhr, form){
										console.log(data);
										if (data.status){
											f.preview(data.result);
											$('.edit_form.infos_form input[name="screenshot"]').val(file);
										}
										$this.screenshot('remove');
										return false;
									},
					dataType:		'json'
				});
			});
			$('button.screenshotcancel').unbind('click').bind('click', function(){
      			$this.screenshot('remove');
      		});
		},
		remove : function( options ) {
			if ( options ) { 
        		$.extend( $.fn.screenshot.defaults, options );
      		}
      		opt = $.fn.screenshot.defaults;
      		console.log(opt.data);
      		$this = $(this);
      		opt.canvas.remove();
      		f.loaded();
      		$this.removeClass('create upload').addClass('show');
      		$('.edit_header.edit_screenshot').addClass('hide');
		}
    };
    
    var f = {
    	drawCanvas : function(elem, canvas){
    		opt = elem.screenshot.defaults;
    		var context = canvas[0].getContext("2d");
			context.clearRect(0, 0, 400, 300);
    		var x = 0; var y = 0; var w = 400; var h = 300;
		 	context.fillStyle = "#EEE";
		    context.fillRect(x, y, w, h);
		    context.fillStyle = "#FFF"; w = 193; h = 143;
		    $.each(opt.positions, function(i,e){
		    	context.fillRect(e.x, e.y, w, h);
		    });
		    elem.screenshot.defaults.text = new CanvasText;
		    elem.screenshot.defaults.image = new Image();
		    var ac = 0;
		    $.each(opt.data, function(i,a){ ac = i; });
		    $.each(opt.data, function(i,a){
		    	var ret = (ac == i)? true : false;
		    	if (a){
		    		console.log(a);
		    		if (a.extern == '1'){
			    		f.getExternalArticel(elem, a.extern_url, a.extern_id, function(d){
			    			a.cache = d.content;
			    			f.draw(elem, canvas[0], context, a, i, ret);
			    		});
			    	} else {
			    		a.extern = false;
			    		f.draw(elem, canvas[0], context, a, i, ret);
			    	}
			    	
		    	} else {
		    		if (ret){ f.returnData(elem, canvas[0]); }
		    	}
		    })
    	},
    	draw : function(elem, canvas, context, article, field, ret){
    		if (article.template == 'image'){
	    		f.drawImage($this, canvas, context, article, ret);
	    	} else if (article.template == 'headline'){
	    		f.drawHeadline($this, canvas, context, article, ret);
	    	} else if (article.template == 'images'){
	    		f.drawImages($this, canvas, context, article, ret);
	    	} else if (article.template == 'text'){
	    		f.drawText($this, canvas, context, article, ret);
	    	} else if (article.template == 'blog'){
	    		f.drawBlog($this, canvas, context, article, field, ret);
	    	} else if (article.template == 'video'){
	    		f.drawVideo($this, canvas, context, article, ret);
	    	}
    	},
    	drawImage : function(elem, canvas, context, article, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		var imgw = Math.round(a.find('.imgtoload').width()*opt.resize);
    		var imgh = Math.round(a.find('.imgtoload').height()*opt.resize);
    		var path = (article.extern)? 'media/getimage.php?path='+article.extern_url+a.find('.imgtoload').data('src') : a.find('.imgtoload').data('src');
    		var max = 140-y;
    		f.canvasImages(elem, context, path, opt.positions[article.field].x+x, opt.positions[article.field].y+y, imgw, imgh, max, function(imgheight){
    			y += imgheight+5;
	    		if (a.find('.text').size() > 0 && y < 140){
	    			var text = $.trim(a.find('.text').text());
	    			f.writeText(elem, canvas, context, text, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
	    		}
	    		if (ret){ f.returnData($this, canvas);}
    		});
    	},
    	drawImages : function(elem, canvas, context, article, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		var images = {};
    		var pos = { top : 0, bottom : 0};
    		var max = 140-y;
    		var count = 0;
    		a.find('.imgtoload').each(function(i,img){
    			var path = (article.extern)? 'media/getimage.php?path='+article.extern_url+a.find('.imgtoload').data('src') : $(this).data('src');
    			images[i] = {
    				width : Math.round($(this).width()*opt.resize),
    				height : Math.round($(this).height()*opt.resize),
    				path : path
    			}
    			if (i < 3){
    				pos.top = (pos.top < Math.round($(this).height()*opt.resize))? Math.round($(this).height()*opt.resize) : pos.top;
    			} else {
    				pos.bottom = (pos.bottom < Math.round($(this).height()*opt.resize))? Math.round($(this).height()*opt.resize) : pos.bottom;
    			}
    			count = i;
    		});
    		$.each(images, function(i,img){
    			var imgx = (i%2 == 0)? opt.positions[article.field].x+x : opt.positions[article.field].x+x+88;
    			if (i == 2){
    				y += pos.top+3;
    				max = 140-y;
    			}
    			var imgy = opt.positions[article.field].y+y
    			if (i < 2){
    				var imgy = (pos.top > img.height)? imgy+((pos.top-img.height)/2): imgy;
    				
    			} else {
    				var imgy = (pos.bottom > img.height)? imgy+((pos.bottom-img.height)/2): imgy;
    			}
    			var imgmax = (max < img.height)? max : img.height;
    			f.canvasImages(elem, context, img.path, imgx, imgy, img.width, img.height, imgmax, function(){
    				if (i == count && ret){
    					f.returnData($this, canvas);
    				}
    			});
    		});
    		
    	},
    	drawHeadline : function(elem, canvas, context, article, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		} else {
    			y += 5;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		y += 10;
    		var hd = a.find('.headline');
    		var text = $.trim(hd.text());
    		text = text.toUpperCase();
    		var font = 'Verdana';
    		hd.find('span').each(function(){
    			if ($(this).hasClass('headline_serif')){
    				font = 'Georgia';
    			}
    		})
    		f.writeHeadline(elem, canvas, context, text, font, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
    		if (ret){ f.returnData($this, canvas); }
    	},
    	drawText : function(elem, canvas, context, article, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		} else {
    			y += 5;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		var text = $.trim(a.find('.text').text());
    		f.writeText(elem, canvas, context, text, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
    		if (ret){ f.returnData($this, canvas); }
    	},
    	drawBlog : function(elem, canvas, context, article, field, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		} else {
    			y += 5;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		var img = a.find('.imgtoload').eq(0);
    		var imgw = Math.round(img.width()*opt.resize);
    		var imgh = Math.round(img.height()*opt.resize);
    		var path = (article.extern)? article.extern_url+img.data('src') : img.data('src');
    		var max = 140-y;
    		f.canvasImages(elem, context, path, opt.positions[article.field].x+x, opt.positions[article.field].y+y, imgw, imgh, max, function(imgheight){
    			y += imgheight+10;
    			var text = $.trim(a.find('.text').eq(0).text());
    			f.writeText(elem, canvas, context, text, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
    			f.crop($this, canvas, field);
    			if (ret){ f.returnData($this, canvas); }
    		});
    		
    		
    	},
    	drawVideo : function(elem, canvas, context, article, ret){
    		opt = elem.screenshot.defaults;
    		var x = 3;
    		var y = 3;
    		if (article.visibility == '1' || article.visibility == '2'){
    			y += 5;
    			f.writeTitle(elem, canvas, context, article.title, opt.positions[article.field].x+x, opt.positions[article.field].y+y);
				y += 10;
    		}
    		if (article.lead != ''){
    			f.writeLead(elem, canvas, context, article.lead, opt.positions[article.field].x+x, opt.positions[article.field].y+y)
				y += 10;
    		}
    		var a = $(article.cache);
    		var imgw = 180;
    		var path = a.find('.video_thumb').attr('src');
    		var max = 140-y;
    		f.canvasImageAspect(elem, context, path, opt.positions[article.field].x+x, opt.positions[article.field].y+y, imgw, max, function(imgheight){
    			if (ret){ f.returnData($this, canvas); }
    		});
    	},
    	canvasImages : function(elem, context, img, x, y, w, h, max, callback){
    		opt = elem.screenshot.defaults;
    		var imgobj = new Image();
		    imgobj.onload = function(){
		    	if (h > max){
		    		var ch = imgobj.height/h*max;
		    		h = max;
		    	} else {
		    		var ch = imgobj.height;
		    	}
		        context.drawImage(imgobj, 0, 0, imgobj.width, ch, x, y, w, h);
		        if (typeof callback == 'function'){ callback(h); }
		    };
		    imgobj.src = img;
    	},
		canvasImageAspect : function(elem, context, img, x, y, w, max, callback){
			opt = elem.screenshot.defaults;
			var imgobj = new Image();
		    imgobj.onload = function(){
		    	var h = w*imgobj.height/imgobj.width
		    	if (h > max){
		    		var ch = imgobj.height/h*max;
		    		h = max;
		    	} else {
		    		var ch = imgobj.height;
		    	}
		        context.drawImage(imgobj, 0, 0, imgobj.width, ch, x, y, w, h);
		        if (typeof callback == 'function'){ callback(h); }
		    };
		    opt.image.src = img;
    	},
    	writeTitle : function(elem, canvas, context, text, x, y){
    		opt = elem.screenshot.defaults;
    		opt.text.config({
			    canvas: canvas, 
			    context: context,
			    fontFamily: "Helvetica Neue",
			    fontSize: "6px",
			    fontWeight: "bold",
			    fontColor: "#000",
			    lineHeight: "8"
			});
			opt.text.drawText({
			    text: text,
			    x: x,
			    y: y,
			    boxWidth: 180
			});
    	},
    	writeLead : function(elem, canvas, context, text, x, y){
    		opt = elem.screenshot.defaults;
    		opt.text.config({
			    canvas: canvas, 
			    context: context,
			    fontFamily: "Helvetica Neue",
			    fontSize: "6px",
			    fontWeight: "normal",
			    fontColor: "#000",
			    lineHeight: "8"
			});
			opt.text.drawText({
			    text: text,
			    x: x,
			    y: y,
			    boxWidth: 180
			});
    	},
    	writeHeadline : function(elem, canvas, context, text, font, x, y){
    		opt = elem.screenshot.defaults;
    		opt.text.config({
			    canvas: canvas, 
			    context: context,
			    fontFamily: font,
			    fontSize: "15px",
			    fontWeight: "bold",
			    fontColor: "#000",
			    lineHeight: "18px"
			});
			opt.text.drawText({
			    text: text,
			    x: x,
			    y: y,
			    boxWidth: 190
			});
    	},
    	writeText : function(elem, canvas, context, text, x, y){
    		opt = elem.screenshot.defaults;
    		opt.text.config({
			    canvas: canvas, 
			    context: context,
			    fontFamily: "Helvetica Neue",
			    fontSize: "6px",
			    fontWeight: "normal",
			    fontColor: "#000",
			    lineHeight: "8"
			});
			opt.text.drawText({
			    text: text,
			    x: x,
			    y: y,
			    boxWidth: 180
			});
    	},
    	crop : function(elem, canvas, field){
    		opt = elem.screenshot.defaults;
    		var context = canvas.getContext("2d");
    		if (field == '1' || field == '2'){
    			var x = 0; var y = 148; var w = 400; var h = 152;
			    context.fillStyle = "#EEE";
			    context.fillRect(x, y, w, h);
			    w = 193; h = 143;
			    context.fillStyle = "#FFF";
			    context.fillRect(opt.positions['3'].x, opt.positions['3'].y, w, h);
			    context.fillRect(opt.positions['4'].x, opt.positions['4'].y, w, h);
    		} else {
    			var x = 0; var y = 295; var w = 400; var h = 5;
    			context.fillStyle = "#EEE";
			    context.fillRect(x, y, w, h);
    		}
    	},
    	getExternalArticel : function(elem, origin, id, callback){
  			$.ajax({
			  	dataType: 'jsonp',
			  	jsonp: 'jsonp_callback',
			  	url: origin+'json/json.php?id='+id,
			  	success: function (data) {
					if (typeof callback == 'function'){ callback(data); }
				}
			});
  		},
  		returnData : function(elem, canvas){
  			elem.screenshot.defaults.rawdata = canvas.toDataURL("image/jpeg");
  			f.loaded();
  		},
    	preview : function(file){
    		var d = new Date();
    		$('#preview_screenshot').empty().append('<img class="screenshot" src="media/'+file+'?'+d.getTime()+'" />');
    	},
    	loading : function(){
			$('#header_loading').addClass('loading');
		},
		loaded : function(){
			$('#header_loading').removeClass('loading');
		},
    };
        
    $.fn.screenshot = function(method) {
  		if ( methods[method] ) {
      		return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    	} else if ( typeof method === 'object' || ! method ) {
      		return methods.init.apply( this, arguments );
    	} else {
      		$.error( 'Method ' +  method + ' does not exist on jQuery.xbmc' );
    	}
    	    
	};
	
	$.fn.screenshot.defaults = {
		data : false,
		articles : false,
		canvas : false,
		scriptpath : 'include/private/js/',
		textscript : false,
		adminpath : false,
		positions : {
			1: { x : 5, y : 5 },
			2: { x : 202, y : 5 },
			3: { x : 5, y : 152 },
			4: { x : 202, y : 152 },
		},
		resize : 191/390,
		text : false,
		image : false,
		rawdata : false
	};
	
})( jQuery );